package com.elinkthings.elink.utils;

import java.io.UnsupportedEncodingException;

public class Base64TeaUitls {
	
	//加密
	public static String  encryptForStr(String dataValue){
		byte[] old = dataValue.getBytes();
		String result = "";
		try {
			//tea加密
			byte[] teaDscrypt =TeaUtils.encrypt(old,null);
			//base编码
			result= Base64Util.encoderString(teaDscrypt);
		} catch (UnsupportedEncodingException e) {
			return result;
		}
		return result;
	}
	
	//加密
	public static String  encrypt(String dataValue){
		byte[] old = BytesUtils.getBytes(Integer.parseInt(dataValue));
		String result = "";
		try {
			//tea加密
			byte[] teaDscrypt =TeaUtils.encrypt(old,null);
			//base编码
			result= Base64Util.encoderString(teaDscrypt);
		} catch (UnsupportedEncodingException e) {
			return result;
		}
		return result;
	}
	
	//解密
	public static byte[] decrypt(String base64Text){
		//base解码
    	String base64TextEn;
		try {
			base64TextEn = Base64Util.decoderString(base64Text);
			//解码数据转换为byte数组
			byte[] base64TeaByteOld = Base64Util.hexStrToByteArray(base64TextEn);
    		//tea解密byte数组	
    		byte[] base64TeaByte =TeaUtils.decrypt(base64TeaByteOld,null);
    		//将负数转换为整数
    		/*if(base64TeaByte != null){
    			for(int i=0;i<base64TeaByte.length;i++){
    				if(base64TeaByte[i]<0){
    					base64TeaByte[i] = (byte) (256 + base64TeaByte[i]); 
    				}
    			}
    		}*/
			return base64TeaByte;
		} catch (UnsupportedEncodingException e) {
			return null;
		}
	}
	
	/**
	 * 十进制转16进制
	 * @param n
	 * @return
	 */
	private static String intToHex(int n) {
        StringBuilder sb = new StringBuilder(8);
        String a;
        char []b = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
        if(n==0){
        	return 0+"";
        }
        while(n != 0){
        	if(n<0){
        		n= 256 +n;
        	}
            sb = sb.append(b[n%16]);
            n = n/16;            
        }
        
        a = sb.reverse().toString();
        /*if(a.length() == 1){
        	a= "0"+a;
        }*/
        return a;
    }
	
	/**
	 * 获取开始下标到结束下标的16进制的值
	 * @param start
	 * @param end
	 * @param params
	 * @return
	 */
	public static String getStartToEndForHex(int start,int end,byte[] params){
		String result = "";
		for(int i=start;i<=end;i++){
			if(i==end){
				result = result+intToHex(params[i]);
			}else{
				result = result+intToHex(params[i])+":";
			}
		}
		return result;
	}
	
	/**
	 * 获取开始下标到结束下标的ASIII对应的值
	 * @param start
	 * @param end
	 * @param params
	 * @return
	 */
	public static String getStartToEndForASIII(int start,int end,byte[] params){
		String result = "";
		for(int i=start;i<=end;i++){
			if(i==end){
				result = result+asciiToString(params[i]+"");
			}else{
				result = result+asciiToString(params[i]+"")+":";
			}
		}
		return result;
	}
	
	/**
	 * ASCII转字符
	 * @param value
	 * @return
	 */
	public static String asciiToString(String value)  
	{  
		value = value.replaceAll(":", "");
	    char c=  (char) Integer.parseInt(value);
	    //System.out.println(value+":"+c);
	    return c+"";
	}
	
	/**
	 * 获取开始下标到结束下标的10进制的值
	 * @param start
	 * @param end
	 * @param params
	 * @return
	 */
	public static String getStartToEndForInt(int start,int end,byte[] params){
		String result = "";
		for(int i=start;i<=end;i++){
			int temp = params[i];
			if(temp < 0){
				temp = 256 + temp;
			}
			if(i==end){
				result = result+temp;
			}else{
				result = result+temp+":";
			}
		}
		return result;
	}
	
	/**
	 * 获取低位到高位的移位＋或运算的值
	 * @param indexLow
	 * @param indexHigh
	 * @param params
	 * @return
	 */
	public static String getLowConactHighEndForInt(int indexLow,int indexHigh,byte[] params){
		String result = "";		
		int tempResult = 0;
		
		for(int i = indexLow;i<=indexHigh;i++){
			int temp = (params[i] < 0 ? 256 + params[i] : params[i]);
			int tempmov = (indexHigh-i)+2;
			tempmov = (i == indexHigh ? 0 : (int) Math.pow(2, tempmov)); 
			tempResult = (temp << tempmov) | tempResult;
		}
		
		return result+tempResult;
	}
	
}
